﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=0.1
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private frm As Form
	Private Table1 As TableView
	Private txtFields As TextArea
	Private blobColumns As Map
End Sub



Public Sub Show(Parent As Form, TableName As String)
	LoadTable(TableName)
	frm.SetOwner(Parent)
	frm.Show
End Sub

Sub CreateRow(Row() As String) As Object()
	Dim labels(Row.Length) As Object
	For i = 0 To Row.Length - 1
		Dim lbl As Label
		lbl.Initialize("")
		lbl.Text = Row(i)
		labels(i) = lbl
	Next
	Return labels
End Sub

Private Sub LoadTable (TableName As String)
	Dim t As List
	t = DBUtils.ExecuteMemoryTable(NWServ.SQL, "PRAGMA table_info ('" & TableName & "')", _
		Null, 0)
	Dim sb, query As StringBuilder
	query.Initialize
	query.Append("SELECT ")
	sb.Initialize
	sb.Append(TableName).Append(" fields:")
	For i = 0 To t.Size - 1
		Dim values() As String
		values = t.Get(i) 't is a list of arrays
		sb.Append(CRLF)
		sb.Append(values(1)).Append(": ").Append(values(2))
		query.Append("[").Append(values(1)).Append("]")
		If values(2) = "BLOB" Then
			blobColumns.Put(i, values(1)) 'find the BLOB columns
		End If
		query.Append(",")
	Next
	txtFields.Text = sb.ToString
	query.Remove(query.Length - 1, query.Length) 'remove last comma
	query.Append(" FROM ").Append(TableName)
	LoadTableContent(query.ToString, blobColumns.Size > 0)
End Sub

Private Sub LoadTableContent (Query As String, ContainsBLOB As Boolean)
	ExecuteTableView(NWServ.SQL, Query, Null, 500, Table1)
End Sub

'This is a modified version of ExecuteTableView which adds ImageViews to Blob fields
Private Sub ExecuteTableView(SQL As SQL, Query As String, StringArgs() As String, Limit As Int, _
	TableView1 As TableView)
	TableView1.Items.Clear
	Dim cur As ResultSet
	If StringArgs = Null Then 
		Dim StringArgs(0) As String
	End If
	cur = SQL.ExecQuery2(Query, StringArgs)
	Dim cols As List
	cols.Initialize
	For i = 0 To cur.ColumnCount - 1
		cols.Add(cur.GetColumnName(i))
	Next
	TableView1.SetColumns(cols)
	Do While cur.NextRow
		Dim values(cur.ColumnCount) As Object
		For col = 0 To cur.ColumnCount - 1
			If blobColumns.ContainsKey(col) Then
				Try
					Dim In As InputStream
					Dim blob() As Byte = cur.GetBlob2(col)
					If blob <> Null And blob.Length > 0 Then
						Log(blob.Length)
						In.InitializeFromBytesArray(blob, 0, blob.Length)
						Dim img As Image
						img.Initialize2(In)
						Dim iv As ImageView
						iv.Initialize("")
						iv.SetImage(img)
						values(col) = iv
					Else
						values(col) = "Empty Blob field"
					End If
				Catch
					values(col) = "Error loading blob as image."
				End Try
			Else
				values(col) = cur.GetString2(col)
			End If
		Next
		TableView1.Items.Add(values)
		If Limit > 0 And TableView1.Items.Size >= Limit Then Exit
	Loop
	cur.Close
	For Each c As Int In blobColumns.Keys
		TableView1.SetColumnSortable(c, False)
	Next
End Sub
