﻿Type=StaticCode
Version=5.82
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
End Sub

Sub findOptimumAxisTicks(range As Float, maxNum As Int, majorTicks() As Float, minorTicks() As Float, noMinorTicks() As Int, noMajorTicks() As Int )
	Dim i As Int
	Dim k As Int
	Dim p As Int
	Dim tickDelta As Float
	Dim tickValsAllowable(3) As Float
	Dim tickError As Float
	Dim tickValue As Float
	Dim minorTickTemp As Float
	Dim majorTickTemp As Float

	tickValsAllowable = Array As Float(0.1, 0.2, 0.5, 1)
	'Determine the scale of the ticks i.e units, tens etc
		tickDelta = range / maxNum

	If tickDelta > 1.0 Then
		Do While tickDelta >= 1.0
			k = k + 1
			tickDelta = tickDelta / 10
		Loop
	Else
		Do While tickDelta * 10 < 1.0
			k = k - 1
			tickDelta = tickDelta * 10
		Loop
	End If

	
	tickError = 1000
	p = 0
	'Now find the allowable tick values that are closest to the tick value of the range
	For i = 0 To 2 
		If tickError > Abs(tickValsAllowable(i) - tickDelta) Then
			tickError = Abs(tickValsAllowable(i) - tickDelta)
			p = p + 1
		End If
	Next
	
	tickValue = tickValsAllowable(p) * Power(10, k)
	
	If range / tickValue < maxNum And p > 0 Then
		p = p - 1
	End If
	
	tickValue = tickValsAllowable(p) * Power(10, k)
	
	If range / tickValue > maxNum And p < 3 Then
		p = p + 1
	End If
	
	majorTickTemp = tickValsAllowable(p) * Power(10, k)

	If p = 0 Or p = 3 Then
		minorTickTemp = majorTickTemp
	End If	
		
	If p = 1 Then
		minorTickTemp = majorTickTemp / 2
	End If
	
	If p = 2 Then
		minorTickTemp = majorTickTemp / 5
	End If
	
	For i = 0 To 20
		If minorTickTemp * i > range Then
			Exit	
		End If
		minorTicks(i) = minorTickTemp * i
	Next
	noMinorTicks(0) = i - 1
	
	For i = 0 To 10 
		If majorTickTemp * i > range Then
			Exit
		End If
		majorTicks(i) = majorTickTemp * i
	Next	
	noMajorTicks(0) = i - 1
End Sub
