﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=5.82
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	
End Sub


Sub ConvertHexStringToInt (Tx As String ) As Int
	Dim i As Int
	Dim Ty As String

	' Guarantee the required string length of 8  e.g. DAB89 => 000DAB89
	i = 8 - Tx.Length

	' ERROR string too Long (or write your own rules please)
	If i < 0 Then
		Return -1
	End If

	' if string is shorter -> fill string with leading Zeros
	If i > 0 Then
		Ty = "00000000".SubString2(0,i) & Tx
	Else
		Ty = Tx
	End If


	' And now lets go binary ;-)
	' convert the higher part first
	i = Bit.ParseInt (Ty.SubString2 (0,4),16)
	' correct the value (lower 16 bits are set to zero by the shift operation)
	i = Bit.ShiftLeft (i,16)
	' add the lower part and combine
	i = Bit.Or (i,Bit.ParseInt (Ty.SubString2 (4,8),16))

	Return i
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub InitializePowerVarsView(TableView1 As TableView)
	'set the columns
	TableView1.SetColumns(Array As String("Parameter","Date", "Time", "Vrms", "Freq", "Supply kW", "Solar kW","Load kW","Supply KWHr","Solar kWHr","Load kWHr","Quality" ))

	Dim row() As Object = CreateRow(Array As String("Instantaneous","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan"))
	TableView1.Items.Add(row)
		
	Dim row() As Object = CreateRow(Array As String("Mean       2 Hr","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan"))
	TableView1.Items.Add(row)
		
	Dim row() As Object = CreateRow(Array As String("Max         2 Hr","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan"))
	TableView1.Items.Add(row)
		
	Dim row() As Object = CreateRow(Array As String("Min          2 Hr","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan"))
	TableView1.Items.Add(row)
			
	Dim row() As Object = CreateRow(Array As String("Std Dev   2 Hr","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan"))
	TableView1.Items.Add(row)
	
	SetColumnStyle(0, "-fx-alignment: center-left;-fx-font-weight: BOLD", TableView1)
	SetColumnStyle(3, "-fx-alignment: center-left;-fx-font-weight: BOLD", TableView1)
End Sub


Public Sub displayStats(TableView1 As TableView)
	
	Dim dateStr As String
	Dim timeStr As String

	dateStr = dateTimeConversions.jdDateTimeToDateStr(NWServ.rtData_s.jTimeEmbed)
	timeStr = dateTimeConversions.jdDateTimeToTimeStr(NWServ.rtData_s.jTimeEmbed)
	
	Dim row() As Object = CreateRow(Array As String("Instantaneous", _ 
													dateStr, _
													timeStr, _
													NumberFormat(NWServ.rtData_s.Vrms,1,4), _ 
													NumberFormat(NWServ.rtData_s.Frequency,1,6), _ 
													NumberFormat(NWServ.rtData_s.P1,1,1), _ 
													NumberFormat(NWServ.rtData_s.P2,1,4), _ 
													NumberFormat(NWServ.rtData_s.P3,1,1), _
													"#nan","#nan","#nan","#nan","#nan","#nan"))											
	TableView1.Items.Set(0,row)

	Dim row() As Object = CreateRow(Array As String("Max         2 Hr", _
													dateStr, _
													timeStr, _
													NumberFormat(NWServ.maxF,1,4), _ 
													NumberFormat(NWServ.maxV,1,6), _ 
													NumberFormat(NWServ.maxSupplykW,1,1), _ 
													NumberFormat(NWServ.maxSolarkW,1,4), _ 
													NumberFormat(NWServ.maxLoadkW,1,1), _
													"#nan","#nan","#nan","#nan","#nan","#nan"))											
	TableView1.Items.Set(2,row)
	
	Dim row() As Object = CreateRow(Array As String("Min         2 Hr", _
													dateStr, _
													timeStr, _
													NumberFormat(NWServ.minF,1,4), _ 
													NumberFormat(NWServ.minV,1,6), _ 
													NumberFormat(NWServ.minSupplykW,1,1), _ 
													NumberFormat(NWServ.minSolarkW,1,4), _ 
													NumberFormat(NWServ.minLoadkW,1,1), _
													"#nan","#nan","#nan","#nan","#nan","#nan"))											
	TableView1.Items.Set(3,row)

End Sub



Sub SetColumnStyle(Index As Int, Style As String, TableView1 As TableView)
	Dim jo As JavaObject = TableView1
	Dim Column As JavaObject = jo.RunMethodJO("getColumns", Null).RunMethod("get", Array(Index))
	Column.RunMethod("setStyle", Array(Style))
End Sub

'Sub SetCellStyle(Index As Int, Style As String, TableView1 As TableView)
'	Dim jo As JavaObject = TableView1
'	Dim Cell As JavaObject = jo.RunMethodJO("getCell", Null).RunMethod("get", Array(Index))
'	Cell.RunMethod("setStyle", Array(Style))
'End Sub

Sub CreateRow(Row() As String) As Object()
	Dim labels(Row.Length) As Object
	For i = 0 To Row.Length - 1
		Dim lbl As Label
		lbl.Initialize("")
		lbl.Text = Row(i)
		labels(i) = lbl
	Next
	Return labels
End Sub
